﻿//-----------------------------------------------
//TUSB-02DAM用ドライバアクセス用API
//Visual C# 用モジュール
//
//2014_02_04　株式会社タートル工業
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

using System.Runtime.InteropServices;

class TUSBDAM
{
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Device_Open(short id);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern void Tusbdam_Device_Close(short id);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Pio_Direction(short id, byte dirR);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Pio_Write(short id, byte dat);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Pio_Read(short id, out byte dat);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Range_Set(short id, byte ch, byte pol, byte range);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Range_Read(short id, byte ch, out byte pol, out byte range);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Clock_Set(short id, byte sel, int clock);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Cycle_Set(short id, short cycle);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Single_Out(short id, byte ch, int Data);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Start(short id, byte sel);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Stop(short id);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Single_Shot(short id);
    [DllImport("USBDAM.DLL", CallingConvention = CallingConvention.Cdecl)]
    public static extern short Tusbdam_Set_Memory(short id, byte ch, short Size, [In] int[] Data);

    public static string GetOpenErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "ID番号が不正です";
            case 3:
                return "すでにデバイスはオープンされています";
            case 4:
                return "接続されている台数が多すぎます";
            case 5:
                return "オープンできませんでした";
            case 6:
                return "デバイスがみつかりません";
            default:
                return "不明なエラーです";
        }
    }
    public static string GetErrMessage(short retcode)
    {
        switch (retcode)
        {
            case 0:
                return "正常終了しました";
            case 1:
                return "デバイスがオープンされていません";
            case 2:
                return "失敗しました";
            default:
                return "不明なエラーです";
        }
    }
}

