
Option Strict Off
Option Explicit On

Imports System.Runtime.InteropServices
Module TUSBDAM
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Device_Open(ByVal id As Short) As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Sub Tusbdam_Device_Close(ByVal id As Short)
    End Sub
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Pio_Direction(ByVal id As Short, _
                                  ByVal dirR As Byte) _
                              As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Pio_Write(ByVal id As Short, _
                               ByVal dat As Byte) _
                           As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Pio_Read(ByVal id As Short, _
                              ByRef dat As Byte) _
                          As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Range_Set(ByVal id As Short, _
                               ByVal ch As Byte, _
                               ByVal pol As Byte, _
                               ByVal range As Byte) _
                           As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Range_Read(ByVal id As Short, _
                                ByVal ch As Byte, _
                                ByRef pol As Byte, _
                                ByRef range As Byte) _
                            As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Clock_Set(ByVal id As Short, _
                               ByVal sel As Byte, _
                               ByVal clock As Integer) _
                           As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Cycle_Set(ByVal id As Short, _
                               ByVal cycle As Short) _
                           As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Single_Out(ByVal id As Short, _
                                ByVal ch As Byte, _
                                ByVal Data As Integer) _
                            As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Start(ByVal id As Short, _
                           ByVal sel As Byte) _
                       As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Stop(ByVal id As Short) As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Single_Shot(ByVal id As Short) As Short
    End Function
    <DllImport("USBDAM.DLL", CallingConvention:=CallingConvention.Cdecl)> _
    Function Tusbdam_Set_Memory(ByVal id As Short, _
                                ByVal ch As Byte, _
                                ByVal Size As Short, _
                                <[In](), Out()> ByVal Data() As Integer) _
                            As Short
    End Function
    ' Open Error Message
    Public Sub Tusbdam_OpenErrorDisp(ByVal ErrCode As Short)
        Dim Message As String

        Select Case ErrCode
            Case 0
                Message = "ɏI܂"
            Case 1
                Message = "IDԍsł"
            Case 3
                Message = "łɃfoCXI[vĂ܂"
            Case 4
                Message = "ڑ䐔܂"
            Case 5
                Message = "I[vo܂ł"
            Case 6
                Message = "foCX܂ł"
            Case Else
                Message = "sȃG[ł"
        End Select

        MsgBox(Message)
    End Sub
    ' Error Message
    Public Sub Tusbdam_ErrorDisp(ByVal ErrCode As Short)
        Dim Message As String

        Select Case ErrCode
            Case 0
                Message = "ɏI܂"
            Case 1
                Message = "foCXI[vĂ܂"
            Case 2
                Message = "s܂"
            Case Else
                Message = "sȃG[ł"
        End Select

        MsgBox(Message)
    End Sub
End Module